from io import IOBase
from typing import Optional, IO


class URLFile(IOBase):
    def __init__(
        self,
        url: str,
        *,
        buffer: Optional[IO[bytes]]=None,
        **kwargs
    ) -> None: ...
    
    @property
    def name(self) -> str: ...
    @property
    def mode(self) -> str: ...
    @property
    def closed(self) -> bool: ...
    @property
    def full(self) -> bool: ...
    
    def readable(self) -> bool: ...
    def seekable(self) -> bool: ...
    def writable(self) -> bool: ...
    
    def tell(self) -> int: ...
    def seek(self, offset: int, whence: int=0) -> None: ...
    def read(self, n: int=-1): ...
    
    def close(self) -> None: ...
